/* moonshot-idcard-widget.c generated by valac 0.26.1, the Vala compiler
 * generated from moonshot-idcard-widget.vala, do not modify */

/*
 * Copyright (c) 2011-2014, JANET(UK)
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * 3. Neither the name of JANET(UK) nor the names of its contributors
 *    may be used to endorse or promote products derived from this software
 *    without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
*/

#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <gdk/gdk.h>
#include <string.h>
#include <stdlib.h>
#include <gdk-pixbuf/gdk-pixbuf.h>
#include <float.h>
#include <math.h>
#include <pango/pango.h>
#include <glib/gi18n-lib.h>
#include <atk/atk.h>


#define TYPE_ID_CARD_WIDGET (id_card_widget_get_type ())
#define ID_CARD_WIDGET(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_ID_CARD_WIDGET, IdCardWidget))
#define ID_CARD_WIDGET_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_ID_CARD_WIDGET, IdCardWidgetClass))
#define IS_ID_CARD_WIDGET(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_ID_CARD_WIDGET))
#define IS_ID_CARD_WIDGET_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_ID_CARD_WIDGET))
#define ID_CARD_WIDGET_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_ID_CARD_WIDGET, IdCardWidgetClass))

typedef struct _IdCardWidget IdCardWidget;
typedef struct _IdCardWidgetClass IdCardWidgetClass;
typedef struct _IdCardWidgetPrivate IdCardWidgetPrivate;

#define TYPE_ID_CARD (id_card_get_type ())
#define ID_CARD(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_ID_CARD, IdCard))
#define ID_CARD_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_ID_CARD, IdCardClass))
#define IS_ID_CARD(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_ID_CARD))
#define IS_ID_CARD_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_ID_CARD))
#define ID_CARD_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_ID_CARD, IdCardClass))

typedef struct _IdCard IdCard;
typedef struct _IdCardClass IdCardClass;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

struct _IdCardWidget {
	GtkBox parent_instance;
	IdCardWidgetPrivate * priv;
};

struct _IdCardWidgetClass {
	GtkBoxClass parent_class;
};

struct _IdCardWidgetPrivate {
	IdCard* _id_card;
	GtkVBox* main_vbox;
	GtkHBox* table;
	GtkButton* _delete_button;
	GtkButton* _details_button;
	GtkButton* _send_button;
	GtkHButtonBox* hbutton_box;
	GtkEventBox* event_box;
	GtkLabel* label;
};


static gpointer id_card_widget_parent_class = NULL;

GType id_card_widget_get_type (void) G_GNUC_CONST;
GType id_card_get_type (void) G_GNUC_CONST;
#define ID_CARD_WIDGET_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_ID_CARD_WIDGET, IdCardWidgetPrivate))
enum  {
	ID_CARD_WIDGET_DUMMY_PROPERTY,
	ID_CARD_WIDGET_ID_CARD,
	ID_CARD_WIDGET_DELETE_BUTTON,
	ID_CARD_WIDGET_DETAILS_BUTTON,
	ID_CARD_WIDGET_SEND_BUTTON
};
void id_card_widget_collapse (IdCardWidget* self);
static void id_card_widget_set_idcard_color (IdCardWidget* self);
void id_card_widget_expand (IdCardWidget* self);
static gboolean id_card_widget_button_press_cb (IdCardWidget* self);
static void id_card_widget_delete_button_cb (IdCardWidget* self);
static void id_card_widget_details_button_cb (IdCardWidget* self);
static void id_card_widget_send_button_cb (IdCardWidget* self);
void id_card_widget_update_id_card_label (IdCardWidget* self);
IdCard* id_card_widget_get_id_card (IdCardWidget* self);
const gchar* id_card_get_display_name (IdCard* self);
gchar** id_card_get_services (IdCard* self, int* result_length1);
IdCardWidget* id_card_widget_new (IdCard* id_card);
IdCardWidget* id_card_widget_construct (GType object_type, IdCard* id_card);
void id_card_widget_set_id_card (IdCardWidget* self, IdCard* value);
GdkPixbuf* get_pixbuf (IdCard* id);
static void id_card_widget_set_delete_button (IdCardWidget* self, GtkButton* value);
static void id_card_widget_set_details_button (IdCardWidget* self, GtkButton* value);
static void id_card_widget_set_send_button (IdCardWidget* self, GtkButton* value);
static void id_card_widget_set_atk_name_description (IdCardWidget* self, GtkWidget* widget, const gchar* name, const gchar* description);
GtkButton* id_card_widget_get_delete_button (IdCardWidget* self);
GtkButton* id_card_widget_get_details_button (IdCardWidget* self);
GtkButton* id_card_widget_get_send_button (IdCardWidget* self);
static void _id_card_widget_delete_button_cb_gtk_button_clicked (GtkButton* _sender, gpointer self);
static void _id_card_widget_details_button_cb_gtk_button_clicked (GtkButton* _sender, gpointer self);
static void _id_card_widget_send_button_cb_gtk_button_clicked (GtkButton* _sender, gpointer self);
static gboolean _id_card_widget_button_press_cb_gtk_widget_button_press_event (GtkWidget* _sender, GdkEventButton* event, gpointer self);
static void id_card_widget_finalize (GObject* obj);
static void _vala_id_card_widget_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_id_card_widget_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);


void id_card_widget_collapse (IdCardWidget* self) {
	GtkHButtonBox* _tmp0_ = NULL;
#line 53 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
	g_return_if_fail (self != NULL);
#line 55 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
	_tmp0_ = self->priv->hbutton_box;
#line 55 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp0_, FALSE);
#line 57 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
	id_card_widget_set_idcard_color (self);
#line 149 "moonshot-idcard-widget.c"
}


void id_card_widget_expand (IdCardWidget* self) {
	GtkHButtonBox* _tmp0_ = NULL;
#line 60 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
	g_return_if_fail (self != NULL);
#line 62 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
	_tmp0_ = self->priv->hbutton_box;
#line 62 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp0_, TRUE);
#line 64 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
	id_card_widget_set_idcard_color (self);
#line 65 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
	g_signal_emit_by_name (self, "expanded");
#line 165 "moonshot-idcard-widget.c"
}


static gboolean id_card_widget_button_press_cb (IdCardWidget* self) {
	gboolean result = FALSE;
	GtkHButtonBox* _tmp0_ = NULL;
	gboolean _tmp1_ = FALSE;
#line 68 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 70 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
	_tmp0_ = self->priv->hbutton_box;
#line 70 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
	_tmp1_ = gtk_widget_get_visible ((GtkWidget*) _tmp0_);
#line 70 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
	if (_tmp1_) {
#line 71 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
		id_card_widget_collapse (self);
#line 183 "moonshot-idcard-widget.c"
	} else {
#line 73 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
		id_card_widget_expand (self);
#line 187 "moonshot-idcard-widget.c"
	}
#line 75 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
	result = FALSE;
#line 75 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
	return result;
#line 193 "moonshot-idcard-widget.c"
}


static void id_card_widget_delete_button_cb (IdCardWidget* self) {
#line 78 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
	g_return_if_fail (self != NULL);
#line 80 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
	g_signal_emit_by_name (self, "remove-id");
#line 202 "moonshot-idcard-widget.c"
}


static void id_card_widget_details_button_cb (IdCardWidget* self) {
#line 83 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
	g_return_if_fail (self != NULL);
#line 85 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
	g_signal_emit_by_name (self, "details-id");
#line 211 "moonshot-idcard-widget.c"
}


static void id_card_widget_send_button_cb (IdCardWidget* self) {
#line 88 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
	g_return_if_fail (self != NULL);
#line 90 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
	g_signal_emit_by_name (self, "send-id");
#line 220 "moonshot-idcard-widget.c"
}


static void id_card_widget_set_idcard_color (IdCardWidget* self) {
	GdkColor color = {0};
	GtkHButtonBox* _tmp0_ = NULL;
	gboolean _tmp1_ = FALSE;
	GtkStateType state = 0;
	GtkStateType _tmp2_ = 0;
	GtkEventBox* _tmp3_ = NULL;
	GdkColor _tmp4_ = {0};
#line 93 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
	g_return_if_fail (self != NULL);
#line 95 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
	memset (&color, 0, sizeof (GdkColor));
#line 97 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
	_tmp0_ = self->priv->hbutton_box;
#line 97 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
	_tmp1_ = gtk_widget_get_visible ((GtkWidget*) _tmp0_);
#line 97 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
	if (_tmp1_ == FALSE) {
#line 99 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
		color.red = (guint16) 65535;
#line 100 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
		color.green = (guint16) 65535;
#line 101 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
		color.blue = (guint16) 65535;
#line 248 "moonshot-idcard-widget.c"
	} else {
#line 105 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
		color.red = (guint16) 33333;
#line 106 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
		color.green = (guint16) 33333;
#line 107 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
		color.blue = (guint16) 60000;
#line 256 "moonshot-idcard-widget.c"
	}
#line 109 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
	_tmp2_ = gtk_widget_get_state ((GtkWidget*) self);
#line 109 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
	state = _tmp2_;
#line 110 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
	_tmp3_ = self->priv->event_box;
#line 110 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
	_tmp4_ = color;
#line 110 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
	gtk_widget_modify_bg ((GtkWidget*) _tmp3_, state, &_tmp4_);
#line 268 "moonshot-idcard-widget.c"
}


void id_card_widget_update_id_card_label (IdCardWidget* self) {
	gchar* services_text = NULL;
	gchar* _tmp0_ = NULL;
	gchar* display_name = NULL;
	IdCard* _tmp1_ = NULL;
	const gchar* _tmp2_ = NULL;
	const gchar* _tmp3_ = NULL;
	gchar* _tmp4_ = NULL;
	GtkLabel* _tmp31_ = NULL;
	const gchar* _tmp32_ = NULL;
	gchar* _tmp33_ = NULL;
	gchar* _tmp34_ = NULL;
	const gchar* _tmp35_ = NULL;
	gchar* _tmp36_ = NULL;
	gchar* _tmp37_ = NULL;
#line 113 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
	g_return_if_fail (self != NULL);
#line 116 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
	_tmp0_ = g_strdup ("");
#line 116 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
	services_text = _tmp0_;
#line 118 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
	_tmp1_ = self->priv->_id_card;
#line 118 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
	_tmp2_ = id_card_get_display_name (_tmp1_);
#line 118 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
	_tmp3_ = _tmp2_;
#line 118 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
	_tmp4_ = g_markup_printf_escaped ("<big>%s</big>", _tmp3_);
#line 118 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
	display_name = _tmp4_;
#line 303 "moonshot-idcard-widget.c"
	{
		gint i = 0;
#line 119 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
		i = 0;
#line 308 "moonshot-idcard-widget.c"
		{
			gboolean _tmp5_ = FALSE;
#line 119 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
			_tmp5_ = TRUE;
#line 119 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
			while (TRUE) {
#line 315 "moonshot-idcard-widget.c"
				gint _tmp7_ = 0;
				IdCard* _tmp8_ = NULL;
				gchar** _tmp9_ = NULL;
				gint _tmp9__length1 = 0;
				gchar** _tmp10_ = NULL;
				gint _tmp10__length1 = 0;
				gchar* service = NULL;
				IdCard* _tmp11_ = NULL;
				gchar** _tmp12_ = NULL;
				gint _tmp12__length1 = 0;
				gchar** _tmp13_ = NULL;
				gint _tmp13__length1 = 0;
				gint _tmp14_ = 0;
				const gchar* _tmp15_ = NULL;
				gchar* _tmp16_ = NULL;
				gint _tmp17_ = 0;
				IdCard* _tmp18_ = NULL;
				gchar** _tmp19_ = NULL;
				gint _tmp19__length1 = 0;
				gchar** _tmp20_ = NULL;
				gint _tmp20__length1 = 0;
#line 119 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
				if (!_tmp5_) {
#line 339 "moonshot-idcard-widget.c"
					gint _tmp6_ = 0;
#line 119 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
					_tmp6_ = i;
#line 119 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
					i = _tmp6_ + 1;
#line 345 "moonshot-idcard-widget.c"
				}
#line 119 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
				_tmp5_ = FALSE;
#line 119 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
				_tmp7_ = i;
#line 119 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
				_tmp8_ = self->priv->_id_card;
#line 119 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
				_tmp9_ = id_card_get_services (_tmp8_, &_tmp9__length1);
#line 119 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
				_tmp10_ = _tmp9_;
#line 119 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
				_tmp10__length1 = _tmp9__length1;
#line 119 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
				if (!(_tmp7_ < _tmp10__length1)) {
#line 119 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
					break;
#line 363 "moonshot-idcard-widget.c"
				}
#line 121 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
				_tmp11_ = self->priv->_id_card;
#line 121 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
				_tmp12_ = id_card_get_services (_tmp11_, &_tmp12__length1);
#line 121 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
				_tmp13_ = _tmp12_;
#line 121 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
				_tmp13__length1 = _tmp12__length1;
#line 121 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
				_tmp14_ = i;
#line 121 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
				_tmp15_ = _tmp13_[_tmp14_];
#line 121 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
				_tmp16_ = g_strdup (_tmp15_);
#line 121 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
				service = _tmp16_;
#line 123 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
				_tmp17_ = i;
#line 123 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
				_tmp18_ = self->priv->_id_card;
#line 123 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
				_tmp19_ = id_card_get_services (_tmp18_, &_tmp19__length1);
#line 123 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
				_tmp20_ = _tmp19_;
#line 123 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
				_tmp20__length1 = _tmp19__length1;
#line 123 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
				if (_tmp17_ == (_tmp20__length1 - 1)) {
#line 393 "moonshot-idcard-widget.c"
					const gchar* _tmp21_ = NULL;
					const gchar* _tmp22_ = NULL;
					gchar* _tmp23_ = NULL;
					gchar* _tmp24_ = NULL;
					gchar* _tmp25_ = NULL;
#line 124 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
					_tmp21_ = services_text;
#line 124 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
					_tmp22_ = service;
#line 124 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
					_tmp23_ = g_markup_printf_escaped ("<i>%s</i>", _tmp22_);
#line 124 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
					_tmp24_ = _tmp23_;
#line 124 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
					_tmp25_ = g_strconcat (_tmp21_, _tmp24_, NULL);
#line 124 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
					_g_free0 (services_text);
#line 124 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
					services_text = _tmp25_;
#line 124 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
					_g_free0 (_tmp24_);
#line 415 "moonshot-idcard-widget.c"
				} else {
					const gchar* _tmp26_ = NULL;
					const gchar* _tmp27_ = NULL;
					gchar* _tmp28_ = NULL;
					gchar* _tmp29_ = NULL;
					gchar* _tmp30_ = NULL;
#line 126 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
					_tmp26_ = services_text;
#line 126 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
					_tmp27_ = service;
#line 126 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
					_tmp28_ = g_markup_printf_escaped ("<i>%s, </i>", _tmp27_);
#line 126 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
					_tmp29_ = _tmp28_;
#line 126 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
					_tmp30_ = g_strconcat (_tmp26_, _tmp29_, NULL);
#line 126 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
					_g_free0 (services_text);
#line 126 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
					services_text = _tmp30_;
#line 126 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
					_g_free0 (_tmp29_);
#line 438 "moonshot-idcard-widget.c"
				}
#line 119 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
				_g_free0 (service);
#line 442 "moonshot-idcard-widget.c"
			}
		}
	}
#line 128 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
	_tmp31_ = self->priv->label;
#line 128 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
	_tmp32_ = display_name;
#line 128 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
	_tmp33_ = g_strconcat (_tmp32_, "\n", NULL);
#line 128 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
	_tmp34_ = _tmp33_;
#line 128 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
	_tmp35_ = services_text;
#line 128 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
	_tmp36_ = g_strconcat (_tmp34_, _tmp35_, NULL);
#line 128 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
	_tmp37_ = _tmp36_;
#line 128 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
	gtk_label_set_markup (_tmp31_, _tmp37_);
#line 128 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
	_g_free0 (_tmp37_);
#line 128 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
	_g_free0 (_tmp34_);
#line 113 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
	_g_free0 (display_name);
#line 113 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
	_g_free0 (services_text);
#line 470 "moonshot-idcard-widget.c"
}


static void _id_card_widget_delete_button_cb_gtk_button_clicked (GtkButton* _sender, gpointer self) {
#line 158 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
	id_card_widget_delete_button_cb ((IdCardWidget*) self);
#line 477 "moonshot-idcard-widget.c"
}


static void _id_card_widget_details_button_cb_gtk_button_clicked (GtkButton* _sender, gpointer self) {
#line 159 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
	id_card_widget_details_button_cb ((IdCardWidget*) self);
#line 484 "moonshot-idcard-widget.c"
}


static void _id_card_widget_send_button_cb_gtk_button_clicked (GtkButton* _sender, gpointer self) {
#line 160 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
	id_card_widget_send_button_cb ((IdCardWidget*) self);
#line 491 "moonshot-idcard-widget.c"
}


static gboolean _id_card_widget_button_press_cb_gtk_widget_button_press_event (GtkWidget* _sender, GdkEventButton* event, gpointer self) {
	gboolean result;
	result = id_card_widget_button_press_cb ((IdCardWidget*) self);
#line 169 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
	return result;
#line 500 "moonshot-idcard-widget.c"
}


IdCardWidget* id_card_widget_construct (GType object_type, IdCard* id_card) {
	IdCardWidget * self = NULL;
	IdCard* _tmp0_ = NULL;
	GtkImage* image = NULL;
	IdCard* _tmp1_ = NULL;
	GdkPixbuf* _tmp2_ = NULL;
	GdkPixbuf* _tmp3_ = NULL;
	GtkImage* _tmp4_ = NULL;
	GtkImage* _tmp5_ = NULL;
	GtkLabel* _tmp6_ = NULL;
	GtkLabel* _tmp7_ = NULL;
	GtkLabel* _tmp8_ = NULL;
	GtkHBox* _tmp9_ = NULL;
	GtkHBox* _tmp10_ = NULL;
	GtkHBox* _tmp11_ = NULL;
	GtkLabel* _tmp12_ = NULL;
	const gchar* _tmp13_ = NULL;
	GtkButton* _tmp14_ = NULL;
	GtkButton* _tmp15_ = NULL;
	const gchar* _tmp16_ = NULL;
	GtkButton* _tmp17_ = NULL;
	GtkButton* _tmp18_ = NULL;
	const gchar* _tmp19_ = NULL;
	GtkButton* _tmp20_ = NULL;
	GtkButton* _tmp21_ = NULL;
	GtkButton* _tmp22_ = NULL;
	const gchar* _tmp23_ = NULL;
	const gchar* _tmp24_ = NULL;
	GtkButton* _tmp25_ = NULL;
	const gchar* _tmp26_ = NULL;
	const gchar* _tmp27_ = NULL;
	GtkButton* _tmp28_ = NULL;
	const gchar* _tmp29_ = NULL;
	const gchar* _tmp30_ = NULL;
	GtkHButtonBox* _tmp31_ = NULL;
	GtkHButtonBox* _tmp32_ = NULL;
	GtkButton* _tmp33_ = NULL;
	GtkHButtonBox* _tmp34_ = NULL;
	GtkButton* _tmp35_ = NULL;
	GtkHButtonBox* _tmp36_ = NULL;
	GtkButton* _tmp37_ = NULL;
	GtkButton* _tmp38_ = NULL;
	GtkButton* _tmp39_ = NULL;
	GtkButton* _tmp40_ = NULL;
	GtkButton* _tmp41_ = NULL;
	GtkVBox* _tmp42_ = NULL;
	GtkVBox* _tmp43_ = NULL;
	GtkHBox* _tmp44_ = NULL;
	GtkVBox* _tmp45_ = NULL;
	GtkHButtonBox* _tmp46_ = NULL;
	GtkVBox* _tmp47_ = NULL;
	GtkEventBox* _tmp48_ = NULL;
	GtkEventBox* _tmp49_ = NULL;
	GtkVBox* _tmp50_ = NULL;
	GtkEventBox* _tmp51_ = NULL;
	GtkEventBox* _tmp52_ = NULL;
	GtkHButtonBox* _tmp53_ = NULL;
#line 131 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
	g_return_val_if_fail (id_card != NULL, NULL);
#line 131 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
	self = (IdCardWidget*) g_object_new (object_type, NULL);
#line 133 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
	_tmp0_ = id_card;
#line 133 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
	id_card_widget_set_id_card (self, _tmp0_);
#line 135 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
	_tmp1_ = id_card;
#line 135 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
	_tmp2_ = get_pixbuf (_tmp1_);
#line 135 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
	_tmp3_ = _tmp2_;
#line 135 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
	_tmp4_ = (GtkImage*) gtk_image_new_from_pixbuf (_tmp3_);
#line 135 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
	g_object_ref_sink (_tmp4_);
#line 135 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
	_tmp5_ = _tmp4_;
#line 135 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
	_g_object_unref0 (_tmp3_);
#line 135 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
	image = _tmp5_;
#line 137 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
	_tmp6_ = (GtkLabel*) gtk_label_new (NULL);
#line 137 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
	g_object_ref_sink (_tmp6_);
#line 137 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
	_g_object_unref0 (self->priv->label);
#line 137 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
	self->priv->label = _tmp6_;
#line 138 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
	_tmp7_ = self->priv->label;
#line 138 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
	gtk_misc_set_alignment ((GtkMisc*) _tmp7_, (gfloat) 0, (gfloat) 0.5);
#line 139 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
	_tmp8_ = self->priv->label;
#line 139 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
	gtk_label_set_ellipsize (_tmp8_, PANGO_ELLIPSIZE_END);
#line 140 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
	id_card_widget_update_id_card_label (self);
#line 142 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
	_tmp9_ = (GtkHBox*) gtk_hbox_new (FALSE, 6);
#line 142 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
	g_object_ref_sink (_tmp9_);
#line 142 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
	_g_object_unref0 (self->priv->table);
#line 142 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
	self->priv->table = _tmp9_;
#line 143 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
	_tmp10_ = self->priv->table;
#line 143 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
	gtk_box_pack_start ((GtkBox*) _tmp10_, (GtkWidget*) image, FALSE, FALSE, (guint) 0);
#line 144 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
	_tmp11_ = self->priv->table;
#line 144 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
	_tmp12_ = self->priv->label;
#line 144 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
	gtk_box_pack_start ((GtkBox*) _tmp11_, (GtkWidget*) _tmp12_, TRUE, TRUE, (guint) 0);
#line 146 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
	_tmp13_ = _ ("Delete");
#line 146 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
	_tmp14_ = (GtkButton*) gtk_button_new_with_label (_tmp13_);
#line 146 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
	g_object_ref_sink (_tmp14_);
#line 146 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
	_tmp15_ = _tmp14_;
#line 146 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
	id_card_widget_set_delete_button (self, _tmp15_);
#line 146 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
	_g_object_unref0 (_tmp15_);
#line 147 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
	_tmp16_ = _ ("View details");
#line 147 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
	_tmp17_ = (GtkButton*) gtk_button_new_with_label (_tmp16_);
#line 147 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
	g_object_ref_sink (_tmp17_);
#line 147 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
	_tmp18_ = _tmp17_;
#line 147 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
	id_card_widget_set_details_button (self, _tmp18_);
#line 147 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
	_g_object_unref0 (_tmp18_);
#line 148 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
	_tmp19_ = _ ("Send");
#line 148 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
	_tmp20_ = (GtkButton*) gtk_button_new_with_label (_tmp19_);
#line 148 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
	g_object_ref_sink (_tmp20_);
#line 148 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
	_tmp21_ = _tmp20_;
#line 148 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
	id_card_widget_set_send_button (self, _tmp21_);
#line 148 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
	_g_object_unref0 (_tmp21_);
#line 149 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
	_tmp22_ = self->priv->_delete_button;
#line 149 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
	_tmp23_ = _ ("Delete");
#line 149 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
	_tmp24_ = _ ("Delete this ID Card");
#line 149 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
	id_card_widget_set_atk_name_description (self, (GtkWidget*) _tmp22_, _tmp23_, _tmp24_);
#line 150 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
	_tmp25_ = self->priv->_details_button;
#line 150 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
	_tmp26_ = _ ("Details");
#line 150 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
	_tmp27_ = _ ("View the details of this ID Card");
#line 150 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
	id_card_widget_set_atk_name_description (self, (GtkWidget*) _tmp25_, _tmp26_, _tmp27_);
#line 151 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
	_tmp28_ = self->priv->_send_button;
#line 151 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
	_tmp29_ = _ ("Send");
#line 151 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
	_tmp30_ = _ ("Send this ID Card");
#line 151 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
	id_card_widget_set_atk_name_description (self, (GtkWidget*) _tmp28_, _tmp29_, _tmp30_);
#line 152 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
	_tmp31_ = (GtkHButtonBox*) gtk_hbutton_box_new ();
#line 152 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
	g_object_ref_sink (_tmp31_);
#line 152 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
	_g_object_unref0 (self->priv->hbutton_box);
#line 152 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
	self->priv->hbutton_box = _tmp31_;
#line 153 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
	_tmp32_ = self->priv->hbutton_box;
#line 153 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
	_tmp33_ = self->priv->_delete_button;
#line 153 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
	gtk_box_pack_end ((GtkBox*) _tmp32_, (GtkWidget*) _tmp33_, TRUE, TRUE, (guint) 0);
#line 154 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
	_tmp34_ = self->priv->hbutton_box;
#line 154 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
	_tmp35_ = self->priv->_details_button;
#line 154 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
	gtk_box_pack_end ((GtkBox*) _tmp34_, (GtkWidget*) _tmp35_, TRUE, TRUE, (guint) 0);
#line 155 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
	_tmp36_ = self->priv->hbutton_box;
#line 155 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
	_tmp37_ = self->priv->_send_button;
#line 155 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
	gtk_box_pack_end ((GtkBox*) _tmp36_, (GtkWidget*) _tmp37_, TRUE, TRUE, (guint) 0);
#line 156 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
	_tmp38_ = self->priv->_send_button;
#line 156 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
	gtk_widget_set_sensitive ((GtkWidget*) _tmp38_, FALSE);
#line 158 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
	_tmp39_ = self->priv->_delete_button;
#line 158 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
	g_signal_connect_object (_tmp39_, "clicked", (GCallback) _id_card_widget_delete_button_cb_gtk_button_clicked, self, 0);
#line 159 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
	_tmp40_ = self->priv->_details_button;
#line 159 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
	g_signal_connect_object (_tmp40_, "clicked", (GCallback) _id_card_widget_details_button_cb_gtk_button_clicked, self, 0);
#line 160 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
	_tmp41_ = self->priv->_send_button;
#line 160 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
	g_signal_connect_object (_tmp41_, "clicked", (GCallback) _id_card_widget_send_button_cb_gtk_button_clicked, self, 0);
#line 162 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
	_tmp42_ = (GtkVBox*) gtk_vbox_new (FALSE, 12);
#line 162 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
	g_object_ref_sink (_tmp42_);
#line 162 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
	_g_object_unref0 (self->priv->main_vbox);
#line 162 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
	self->priv->main_vbox = _tmp42_;
#line 163 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
	_tmp43_ = self->priv->main_vbox;
#line 163 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
	_tmp44_ = self->priv->table;
#line 163 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
	gtk_box_pack_start ((GtkBox*) _tmp43_, (GtkWidget*) _tmp44_, TRUE, TRUE, (guint) 0);
#line 164 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
	_tmp45_ = self->priv->main_vbox;
#line 164 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
	_tmp46_ = self->priv->hbutton_box;
#line 164 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
	gtk_box_pack_start ((GtkBox*) _tmp45_, (GtkWidget*) _tmp46_, FALSE, FALSE, (guint) 0);
#line 165 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
	_tmp47_ = self->priv->main_vbox;
#line 165 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
	gtk_container_set_border_width ((GtkContainer*) _tmp47_, (guint) 12);
#line 167 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
	_tmp48_ = (GtkEventBox*) gtk_event_box_new ();
#line 167 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
	g_object_ref_sink (_tmp48_);
#line 167 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
	_g_object_unref0 (self->priv->event_box);
#line 167 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
	self->priv->event_box = _tmp48_;
#line 168 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
	_tmp49_ = self->priv->event_box;
#line 168 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
	_tmp50_ = self->priv->main_vbox;
#line 168 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
	gtk_container_add ((GtkContainer*) _tmp49_, (GtkWidget*) _tmp50_);
#line 169 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
	_tmp51_ = self->priv->event_box;
#line 169 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
	g_signal_connect_object ((GtkWidget*) _tmp51_, "button-press-event", (GCallback) _id_card_widget_button_press_cb_gtk_widget_button_press_event, self, 0);
#line 170 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
	_tmp52_ = self->priv->event_box;
#line 170 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
	gtk_box_pack_start ((GtkBox*) self, (GtkWidget*) _tmp52_, TRUE, TRUE, (guint) 0);
#line 172 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
	gtk_widget_show_all ((GtkWidget*) self);
#line 173 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
	_tmp53_ = self->priv->hbutton_box;
#line 173 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
	gtk_widget_hide ((GtkWidget*) _tmp53_);
#line 175 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
	id_card_widget_set_idcard_color (self);
#line 131 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
	_g_object_unref0 (image);
#line 131 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
	return self;
#line 781 "moonshot-idcard-widget.c"
}


IdCardWidget* id_card_widget_new (IdCard* id_card) {
#line 131 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
	return id_card_widget_construct (TYPE_ID_CARD_WIDGET, id_card);
#line 788 "moonshot-idcard-widget.c"
}


static gpointer _g_object_ref0 (gpointer self) {
#line 180 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
	return self ? g_object_ref (self) : NULL;
#line 795 "moonshot-idcard-widget.c"
}


static void id_card_widget_set_atk_name_description (IdCardWidget* self, GtkWidget* widget, const gchar* name, const gchar* description) {
	AtkObject* atk_widget = NULL;
	GtkWidget* _tmp0_ = NULL;
	AtkObject* _tmp1_ = NULL;
	AtkObject* _tmp2_ = NULL;
	const gchar* _tmp3_ = NULL;
	const gchar* _tmp4_ = NULL;
#line 178 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
	g_return_if_fail (self != NULL);
#line 178 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
	g_return_if_fail (widget != NULL);
#line 178 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
	g_return_if_fail (name != NULL);
#line 178 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
	g_return_if_fail (description != NULL);
#line 180 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
	_tmp0_ = widget;
#line 180 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
	_tmp1_ = gtk_widget_get_accessible (_tmp0_);
#line 180 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
	_tmp2_ = _g_object_ref0 (_tmp1_);
#line 180 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
	atk_widget = _tmp2_;
#line 182 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
	_tmp3_ = name;
#line 182 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
	atk_object_set_name (atk_widget, _tmp3_);
#line 183 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
	_tmp4_ = description;
#line 183 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
	atk_object_set_description (atk_widget, _tmp4_);
#line 178 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
	_g_object_unref0 (atk_widget);
#line 832 "moonshot-idcard-widget.c"
}


IdCard* id_card_widget_get_id_card (IdCardWidget* self) {
	IdCard* result;
	IdCard* _tmp0_ = NULL;
#line 36 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 36 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
	_tmp0_ = self->priv->_id_card;
#line 36 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
	result = _tmp0_;
#line 36 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
	return result;
#line 847 "moonshot-idcard-widget.c"
}


void id_card_widget_set_id_card (IdCardWidget* self, IdCard* value) {
	IdCard* _tmp0_ = NULL;
	IdCard* _tmp1_ = NULL;
#line 36 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
	g_return_if_fail (self != NULL);
#line 36 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
	_tmp0_ = value;
#line 36 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 36 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
	_g_object_unref0 (self->priv->_id_card);
#line 36 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
	self->priv->_id_card = _tmp1_;
#line 36 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
	g_object_notify ((GObject *) self, "id-card");
#line 866 "moonshot-idcard-widget.c"
}


GtkButton* id_card_widget_get_delete_button (IdCardWidget* self) {
	GtkButton* result;
	GtkButton* _tmp0_ = NULL;
#line 40 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 40 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
	_tmp0_ = self->priv->_delete_button;
#line 40 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
	result = _tmp0_;
#line 40 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
	return result;
#line 881 "moonshot-idcard-widget.c"
}


static void id_card_widget_set_delete_button (IdCardWidget* self, GtkButton* value) {
	GtkButton* _tmp0_ = NULL;
	GtkButton* _tmp1_ = NULL;
#line 40 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
	g_return_if_fail (self != NULL);
#line 40 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
	_tmp0_ = value;
#line 40 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 40 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
	_g_object_unref0 (self->priv->_delete_button);
#line 40 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
	self->priv->_delete_button = _tmp1_;
#line 40 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
	g_object_notify ((GObject *) self, "delete-button");
#line 900 "moonshot-idcard-widget.c"
}


GtkButton* id_card_widget_get_details_button (IdCardWidget* self) {
	GtkButton* result;
	GtkButton* _tmp0_ = NULL;
#line 41 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 41 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
	_tmp0_ = self->priv->_details_button;
#line 41 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
	result = _tmp0_;
#line 41 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
	return result;
#line 915 "moonshot-idcard-widget.c"
}


static void id_card_widget_set_details_button (IdCardWidget* self, GtkButton* value) {
	GtkButton* _tmp0_ = NULL;
	GtkButton* _tmp1_ = NULL;
#line 41 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
	g_return_if_fail (self != NULL);
#line 41 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
	_tmp0_ = value;
#line 41 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 41 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
	_g_object_unref0 (self->priv->_details_button);
#line 41 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
	self->priv->_details_button = _tmp1_;
#line 41 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
	g_object_notify ((GObject *) self, "details-button");
#line 934 "moonshot-idcard-widget.c"
}


GtkButton* id_card_widget_get_send_button (IdCardWidget* self) {
	GtkButton* result;
	GtkButton* _tmp0_ = NULL;
#line 42 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 42 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
	_tmp0_ = self->priv->_send_button;
#line 42 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
	result = _tmp0_;
#line 42 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
	return result;
#line 949 "moonshot-idcard-widget.c"
}


static void id_card_widget_set_send_button (IdCardWidget* self, GtkButton* value) {
	GtkButton* _tmp0_ = NULL;
	GtkButton* _tmp1_ = NULL;
#line 42 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
	g_return_if_fail (self != NULL);
#line 42 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
	_tmp0_ = value;
#line 42 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 42 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
	_g_object_unref0 (self->priv->_send_button);
#line 42 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
	self->priv->_send_button = _tmp1_;
#line 42 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
	g_object_notify ((GObject *) self, "send-button");
#line 968 "moonshot-idcard-widget.c"
}


static void id_card_widget_class_init (IdCardWidgetClass * klass) {
#line 34 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
	id_card_widget_parent_class = g_type_class_peek_parent (klass);
#line 34 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
	g_type_class_add_private (klass, sizeof (IdCardWidgetPrivate));
#line 34 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_id_card_widget_get_property;
#line 34 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_id_card_widget_set_property;
#line 34 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
	G_OBJECT_CLASS (klass)->finalize = id_card_widget_finalize;
#line 34 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), ID_CARD_WIDGET_ID_CARD, g_param_spec_object ("id-card", "id-card", "id-card", TYPE_ID_CARD, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 34 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), ID_CARD_WIDGET_DELETE_BUTTON, g_param_spec_object ("delete-button", "delete-button", "delete-button", GTK_TYPE_BUTTON, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
#line 34 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), ID_CARD_WIDGET_DETAILS_BUTTON, g_param_spec_object ("details-button", "details-button", "details-button", GTK_TYPE_BUTTON, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
#line 34 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), ID_CARD_WIDGET_SEND_BUTTON, g_param_spec_object ("send-button", "send-button", "send-button", GTK_TYPE_BUTTON, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
#line 34 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
	g_signal_new ("expanded", TYPE_ID_CARD_WIDGET, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 34 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
	g_signal_new ("remove_id", TYPE_ID_CARD_WIDGET, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 34 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
	g_signal_new ("details_id", TYPE_ID_CARD_WIDGET, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 34 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
	g_signal_new ("send_id", TYPE_ID_CARD_WIDGET, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 999 "moonshot-idcard-widget.c"
}


static void id_card_widget_instance_init (IdCardWidget * self) {
#line 34 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
	self->priv = ID_CARD_WIDGET_GET_PRIVATE (self);
#line 36 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
	self->priv->_id_card = NULL;
#line 40 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
	self->priv->_delete_button = NULL;
#line 41 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
	self->priv->_details_button = NULL;
#line 42 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
	self->priv->_send_button = NULL;
#line 1014 "moonshot-idcard-widget.c"
}


static void id_card_widget_finalize (GObject* obj) {
	IdCardWidget * self;
#line 34 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_ID_CARD_WIDGET, IdCardWidget);
#line 36 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
	_g_object_unref0 (self->priv->_id_card);
#line 38 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
	_g_object_unref0 (self->priv->main_vbox);
#line 39 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
	_g_object_unref0 (self->priv->table);
#line 40 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
	_g_object_unref0 (self->priv->_delete_button);
#line 41 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
	_g_object_unref0 (self->priv->_details_button);
#line 42 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
	_g_object_unref0 (self->priv->_send_button);
#line 43 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
	_g_object_unref0 (self->priv->hbutton_box);
#line 44 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
	_g_object_unref0 (self->priv->event_box);
#line 46 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
	_g_object_unref0 (self->priv->label);
#line 34 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
	G_OBJECT_CLASS (id_card_widget_parent_class)->finalize (obj);
#line 1042 "moonshot-idcard-widget.c"
}


GType id_card_widget_get_type (void) {
	static volatile gsize id_card_widget_type_id__volatile = 0;
	if (g_once_init_enter (&id_card_widget_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (IdCardWidgetClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) id_card_widget_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (IdCardWidget), 0, (GInstanceInitFunc) id_card_widget_instance_init, NULL };
		GType id_card_widget_type_id;
		id_card_widget_type_id = g_type_register_static (GTK_TYPE_BOX, "IdCardWidget", &g_define_type_info, 0);
		g_once_init_leave (&id_card_widget_type_id__volatile, id_card_widget_type_id);
	}
	return id_card_widget_type_id__volatile;
}


static void _vala_id_card_widget_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	IdCardWidget * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_ID_CARD_WIDGET, IdCardWidget);
#line 34 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
	switch (property_id) {
#line 34 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
		case ID_CARD_WIDGET_ID_CARD:
#line 34 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
		g_value_set_object (value, id_card_widget_get_id_card (self));
#line 34 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
		break;
#line 34 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
		case ID_CARD_WIDGET_DELETE_BUTTON:
#line 34 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
		g_value_set_object (value, id_card_widget_get_delete_button (self));
#line 34 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
		break;
#line 34 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
		case ID_CARD_WIDGET_DETAILS_BUTTON:
#line 34 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
		g_value_set_object (value, id_card_widget_get_details_button (self));
#line 34 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
		break;
#line 34 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
		case ID_CARD_WIDGET_SEND_BUTTON:
#line 34 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
		g_value_set_object (value, id_card_widget_get_send_button (self));
#line 34 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
		break;
#line 1087 "moonshot-idcard-widget.c"
		default:
#line 34 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 34 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
		break;
#line 1093 "moonshot-idcard-widget.c"
	}
}


static void _vala_id_card_widget_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	IdCardWidget * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_ID_CARD_WIDGET, IdCardWidget);
#line 34 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
	switch (property_id) {
#line 34 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
		case ID_CARD_WIDGET_ID_CARD:
#line 34 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
		id_card_widget_set_id_card (self, g_value_get_object (value));
#line 34 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
		break;
#line 34 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
		case ID_CARD_WIDGET_DELETE_BUTTON:
#line 34 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
		id_card_widget_set_delete_button (self, g_value_get_object (value));
#line 34 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
		break;
#line 34 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
		case ID_CARD_WIDGET_DETAILS_BUTTON:
#line 34 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
		id_card_widget_set_details_button (self, g_value_get_object (value));
#line 34 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
		break;
#line 34 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
		case ID_CARD_WIDGET_SEND_BUTTON:
#line 34 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
		id_card_widget_set_send_button (self, g_value_get_object (value));
#line 34 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
		break;
#line 1127 "moonshot-idcard-widget.c"
		default:
#line 34 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 34 "/home/DEV/jennifer/testing/moonshot/ui/src/moonshot-idcard-widget.vala"
		break;
#line 1133 "moonshot-idcard-widget.c"
	}
}



